Index: attribute.dd
===================================================================
--- attribute.dd	(revision 1638)
+++ attribute.dd	(working copy)
@@ -2,37 +2,11 @@
 
 $(SPEC_S Attributes,
 
-$(GRAMMAR
-$(GNAME AttributeSpecifier):
-    $(I Attribute) $(B :)
-    $(I Attribute) $(I DeclarationBlock)
+$(AttributeSpecifier_production)
+$(Attribute_production)
 
-$(GNAME Attribute):
-    $(LINK2 #linkage, $(I LinkageAttribute))
-    $(LINK2 #align, $(I AlignAttribute))
-    $(LINK2 pragma.html, $(I Pragma))
-    $(LINK2 #deprecated, $(B deprecated))
-    $(GLINK ProtectionAttribute)
-    $(B static)
-    $(B final)
-    $(LINK2 #override, $(B override))
-    $(LINK2 #abstract, $(B abstract))
-    $(LINK2 #const, $(B const))
-    $(LINK2 #auto, $(B auto))
-    $(LINK2 #scope, $(B scope))
-$(V2    $(LINK2 #gshared, $(B __gshared))
-    $(LINK2 #shared, $(B shared))
-    $(LINK2 #immutable, $(B immutable))
-    $(LINK2 #inout, $(B inout))
-    $(LINK2 #disable, $(B @disable))
-)
+$(DeclarationBlock_production)
 
-$(GNAME DeclarationBlock):
-    $(LINK2 module.html#DeclDef, $(I DeclDef))
-    $(B { })
-    $(B {) $(LINK2 module.html#DeclDefs, $(I DeclDefs)) $(B })
-)
-
 	$(P Attributes are a way to modify one or more declarations.
 	The general forms are:
 	)
@@ -78,20 +52,9 @@
 
 <h2>$(LNAME2 linkage, Linkage Attribute)</h2>
 
-$(GRAMMAR
-$(GNAME LinkageAttribute):
-	$(B extern)
-	$(B extern) $(B $(LPAREN)) $(I LinkageType) $(B $(RPAREN))
+$(LinkageAttribute_production)
+$(LinkageType_production)
 
-$(GNAME LinkageType):
-	$(B C)
-	$(B C++)
-	$(B D)
-	$(B Windows)
-	$(B Pascal)
-	$(B System)
-)
-
 	$(P D provides an easy way to call C functions and operating
 	system API functions, as compatibility with both is essential.
 	The $(I LinkageType) is case sensitive, and is meant to be
@@ -141,11 +104,7 @@
 
 <h2>$(LNAME2 align, Align Attribute)</h2>
 
-$(GRAMMAR
-$(GNAME AlignAttribute):
-	$(B align)
-	$(B align) $(B $(LPAREN)) $(I Integer) $(B $(RPAREN))
-)
+$(AlignAttribute_production)
 
 	$(P Specifies the alignment of struct members. $(B align) by itself
 	sets it to the default, which matches the default member alignment
@@ -227,14 +186,7 @@
 
 <h2>Protection Attribute</h2>
 
-$(GRAMMAR
-$(GNAME ProtectionAttribute):
-    $(B private)
-    $(B package)
-    $(B protected)
-    $(B public)
-    $(B export)
-)
+$(ProtectionAttribute_production)
 
 	$(P Protection is an attribute that is one of
 	$(B private), $(B package), $(B protected),
Index: class.dd
===================================================================
--- class.dd	(revision 1638)
+++ class.dd	(working copy)
@@ -23,55 +23,16 @@
 	$(P A class declaration is defined:
 	)
 
-$(GRAMMAR
-$(GNAME ClassDeclaration):
-	$(B class) $(I Identifier) $(I BaseClassList) $(I ClassBody)
-	$(LINK2 template.html#ClassTemplateDeclaration, $(I ClassTemplateDeclaration))
+$(ClassDeclaration_production)
+$(BaseClassList_production)
+$(SuperClass_production)
+$(InterfaceClasses_production)
+$(InterfaceClass_production)
+$(Protection_production)
+$(ClassBody_production)
+$(ClassBodyDeclarations_production)
+$(ClassBodyDeclaration_production)
 
-$(GNAME BaseClassList):
-	$(I Empty)
-	$(B :) $(I SuperClass)
-	$(B :) $(I SuperClass) $(B ,) $(I InterfaceClasses)
-	$(B :) $(I InterfaceClass)
-
-$(GNAME SuperClass):
-	$(I Identifier)
-	$(I Protection) $(I Identifier)
-
-$(GNAME InterfaceClasses):
-	$(I InterfaceClass)
-	$(I InterfaceClass) $(B ,) $(I InterfaceClasses)
-
-$(GNAME InterfaceClass):
-	$(I Identifier)
-	$(I Protection) $(I Identifier)
-
-$(GNAME Protection):
-	$(B private)
-	$(B package)
-	$(B public)
-	$(B export)
-
-$(GNAME ClassBody):
-	$(B {) $(B })
-	$(B {) $(I ClassBodyDeclarations) $(B })
-
-$(GNAME ClassBodyDeclarations):
-	$(I ClassBodyDeclaration)
-	$(I ClassBodyDeclaration) $(I ClassBodyDeclarations)
-
-$(GNAME ClassBodyDeclaration):
-	$(I Declaration)
-	$(GLINK Constructor)
-	$(GLINK Destructor)
-	$(GLINK StaticConstructor)
-	$(GLINK StaticDestructor)
-	$(GLINK Invariant)
-	$(GLINK UnitTest)
-	$(GLINK ClassAllocator)
-	$(GLINK ClassDeallocator)
-)
-
 Classes consist of:
 
 $(UL
@@ -242,10 +203,7 @@
 
 <h3>$(LNAME2 constructors, Constructors)</h3>
 
-$(GRAMMAR
-$(GNAME Constructor):
-	$(B this) $(I Parameters) $(I FunctionBody)
-)
+$(Constructor_production)
 
 	$(P Members are always initialized to the
 	$(LNAME2 class-default-initializer, default initializer)
@@ -417,10 +375,7 @@
 
 <h3>$(LNAME2 destructors, Destructors)</h3>
 
-$(GRAMMAR
-$(GNAME Destructor):
-	$(B ~this()) $(I FunctionBody)
-)
+$(Destructor_production)
 
 	The garbage collector calls the destructor function when the object
 	is deleted. The syntax 
@@ -477,10 +432,7 @@
 
 <h3>Static Constructors</h3>
 
-$(GRAMMAR
-$(GNAME StaticConstructor):
-	$(B static this()) $(I FunctionBody)
-)
+$(StaticConstructor_production)
 
 	A static constructor is defined as a function that performs
 	initializations before the 
@@ -571,10 +523,7 @@
 
 <h3>Static Destructors</h3>
 
-$(GRAMMAR
-$(GNAME StaticDestructor):
-	$(B static ~this()) $(I FunctionBody)
-)
+$(StaticDestructor_production)
 
 	A static destructor is defined as a special static function with the
 	syntax $(TT static ~this()).
@@ -616,10 +565,7 @@
 $(V2
 <h3>Shared Static Constructors</h3>
 
-$(GRAMMAR
-$(GNAME SharedStaticConstructor):
-	$(B shared static this()) $(I FunctionBody)
-)
+$(SharedStaticConstructor_production)
 
 	$(P Shared static constructors are executed before any $(GLINK StaticConstructor)s,
 	and are intended for initializing any shared global data.
@@ -627,10 +573,7 @@
 
 <h3>Shared Static Destructors</h3>
 
-$(GRAMMAR
-$(GNAME SharedStaticDestructor):
-	$(B shared static ~this()) $(I FunctionBody)
-)
+$(SharedStaticDestructor_production)
 
 	$(P Shared static destructors are executed at program termination
 	in the reverse order that
@@ -640,10 +583,7 @@
 
 <h3>$(LNAME2 invariants, Class Invariants)</h3>
 
-$(GRAMMAR
-$(GNAME Invariant):
-	$(B invariant()) $(I BlockStatement)
-)
+$(Invariant_production)
 
     Class invariants are used to specify characteristics of a class that always
     must be true (except while executing a member function). For example, a
@@ -722,10 +662,7 @@
 
 <h3>$(LNAME2 allocators, Class Allocators)</h3>
 
-$(GRAMMAR
-$(GNAME ClassAllocator):
-	$(B new) $(I Parameters) $(I FunctionBody)
-)
+$(ClassAllocator_production)
 
 	A class member function of the form:
 
@@ -789,10 +726,7 @@
 
 <h3>$(LNAME2 deallocators, Class Deallocators)</h3>
 
-$(GRAMMAR
-$(GNAME ClassDeallocator):
-	$(B delete) $(I Parameters) $(I FunctionBody)
-)
+$(ClassDeallocator_production)
 
 	A class member function of the form:
 
@@ -834,10 +768,7 @@
 $(V2
 <h3>$(LNAME2 AliasThis, Alias This)</h3>
 
-$(GRAMMAR
-$(GNAME AliasThis):
-	$(B alias) $(I Identifier) $(B this;)
-)
+$(AliasThis_production)
 
 	$(P An $(I AliasThis) declaration names another class or struct member
 	to which any undefined lookups will be forwarded.
@@ -1143,14 +1074,9 @@
 	a $(I NewAnonClassExpression):
 	)
 
-$(GRAMMAR
-$(GNAME NewAnonClassExpression):
-    $(B new) $(I PerenArgumentList)<sub>opt</sub> $(B class) $(I PerenArgumentList)<sub>opt</sub> $(I SuperClass)<sub>opt</sub> $(I InterfaceClasses)<sub>opt</sub> $(I ClassBody)
+$(NewAnonClassExpression_production)
+$(PerenArgumentList_production)
 
-$(GNAME PerenArgumentList):
-    $(B $(LPAREN))$(I ArgumentList)$(B $(RPAREN))
-)
-
 	$(P which is equivalent to:
 	)
 
Index: declaration.dd
===================================================================
--- declaration.dd	(revision 1638)
+++ declaration.dd	(working copy)
@@ -2,214 +2,43 @@
 
 $(SPEC_S Declarations,
 
-$(GRAMMAR
-$(GNAME Declaration):
-$(V1        $(B typedef) $(I Decl)
-)        $(B alias) $(I Decl)
-        $(I Decl)
-
-$(GNAME Decl):
-        $(GLINK StorageClasses) $(I Decl)
-        $(GLINK BasicType) $(GLINK Declarators) $(B ;)
-        $(GLINK BasicType) $(GLINK Declarator) $(LINK2 function.html#FunctionBody, $(I FunctionBody))
-	$(GLINK AutoDeclaration)
-
-$(GNAME Declarators):
-        $(I DeclaratorInitializer)
-        $(I DeclaratorInitializer) $(B ,) $(GLINK DeclaratorIdentifierList)
-
-$(GNAME DeclaratorInitializer):
-        $(GLINK Declarator)
-        $(GLINK Declarator) $(B =) $(GLINK Initializer)
-
-$(GNAME DeclaratorIdentifierList):
-        $(GLINK DeclaratorIdentifier)
-        $(GLINK DeclaratorIdentifier) $(B ,) $(I DeclaratorIdentifierList)
-
-$(GNAME DeclaratorIdentifier):
-        $(I Identifier)
-        $(I Identifier) $(B =) $(GLINK Initializer)
-
-$(GNAME BasicType):
-	$(GLINK BasicTypeX)
-        $(B .)$(GLINK IdentifierList)
-        $(GLINK IdentifierList)
-        $(GLINK Typeof)
-        $(GLINK Typeof) $(B .) $(GLINK IdentifierList)
-$(V2          $(B const$(LPAREN)) $(GLINK type) $(B $(RPAREN))
-        $(B immutable$(LPAREN)) $(GLINK type) $(B $(RPAREN))
-        $(B shared$(LPAREN)) $(GLINK type) $(B $(RPAREN))
-        $(B inout$(LPAREN)) $(GLINK type) $(B $(RPAREN))
-)
-
-$(GNAME BasicTypeX):
-        $(B bool)
-        $(B byte)
-        $(B ubyte)
-        $(B short)
-        $(B ushort)
-        $(B int)
-        $(B uint)
-        $(B long)
-        $(B ulong)
-        $(B char)
-        $(B wchar)
-        $(B dchar)
-        $(B float)
-        $(B double)
-        $(B real)
-        $(B ifloat)
-        $(B idouble)
-        $(B ireal)
-        $(B cfloat)
-        $(B cdouble)
-        $(B creal)
-        $(B void)
-
-$(GNAME BasicType2):
-        $(B *)
-        $(B [ ])
-        $(B [) $(VEXPRESSION) $(B ])
-        $(B [) $(VEXPRESSION) .. $(VEXPRESSION) $(B ])
-        $(B [) $(I Type) $(B ])
-        $(B delegate) $(GLINK Parameters) $(V2 $(GLINK FunctionAttributes)$(OPT))
-        $(B function) $(GLINK Parameters) $(V2 $(GLINK FunctionAttributes)$(OPT))
-
-$(GNAME Declarator):
-        $(GLINK BasicType2)$(OPT) $(I Declarator) $(GLINK DeclaratorSuffixes)$(OPT)
-        $(GLINK BasicType2)$(OPT) $(I Identifier) $(GLINK DeclaratorSuffixes)$(OPT)
-
-$(GNAME DeclaratorSuffixes):
-        $(GLINK DeclaratorSuffix)
-        $(GLINK DeclaratorSuffix) $(I DeclaratorSuffixes)
-
-$(GNAME DeclaratorSuffix):
-        $(B [ ])
-        $(B [) $(VEXPRESSION) $(B ])
-        $(B [) $(I Type) $(B ])
-	$(LINK2 template.html#TemplateParameterList, $(I TemplateParameterList))$(OPT) $(GLINK Parameters) $(V2 $(GLINK MemberFunctionAttributes)<sub>opt</sub>)
-
-$(GNAME IdentifierList):
-        $(I Identifier)
-        $(I Identifier) $(B .) $(I IdentifierList)
-        $(I TemplateInstance)
-        $(I TemplateInstance) $(B .) $(I IdentifierList)
-
-$(GNAME StorageClasses):
-	$(GLINK StorageClass)
-	$(GLINK StorageClass) $(I StorageClasses)
-
-$(GNAME StorageClass):
-        $(B abstract)
-        $(B auto)
-        $(B const)
-        $(B deprecated)
-        $(B extern)
-        $(B final)
+$(Declaration_production)
+$(Decl_production)
+$(Declarators_production)
+$(DeclaratorInitializer_production)
+$(DeclaratorIdentifierList_production)
+$(DeclaratorIdentifier_production)
+$(BasicType_production)
+$(BasicTypeX_production)
+$(BasicType2_production)
+$(Declarator_production)
+$(DeclaratorSuffixes_production)
+$(DeclaratorSuffix_production)
+$(IdentifierList_production)
+$(StorageClasses_production)
+$(StorageClass_production)
+$(Type_production)
+$(Declarator2_production)
+$(Parameters_production)
+$(ParameterList_production)
+$(Parameter_production)
+$(InOut_production)
 $(V2
-        $(B immutable)
-        $(B inout)
-        $(B shared)
-	$(B nothrow)
-        $(B override)
-	$(B pure)
-)        $(B scope)
-        $(B static)
-        $(B synchronized)
-
-$(GNAME Type):
-        $(GLINK BasicType)
-        $(GLINK BasicType) $(GLINK Declarator2)
-
-$(GNAME Declarator2):
-        $(GLINK BasicType2) $(I Declarator2)
-        $(B $(LPAREN)) $(I Declarator2) $(B $(RPAREN))
-        $(B $(LPAREN)) $(I Declarator2) $(B $(RPAREN)) $(GLINK DeclaratorSuffixes)
-
-$(GNAME Parameters):
-	$(B $(LPAREN)) $(GLINK ParameterList) $(B $(RPAREN))
-	$(B ( ))
-
-$(GNAME ParameterList):
-        $(GLINK Parameter)
-        $(GLINK Parameter) $(B ,) $(I ParameterList)
-        $(GLINK Parameter) $(B ...)
-        $(B ...)
-
-$(GNAME Parameter):
-        $(GLINK Declarator)
-        $(GLINK Declarator) = $(I DefaultInitializerExpression)
-        $(I InOut) $(GLINK Declarator)
-        $(I InOut) $(GLINK Declarator) = $(I DefaultInitializerExpression)
-
-$(GNAME InOut):
-        $(B in)
-        $(B out)
-        $(B ref)
-        $(B lazy)
-
-$(V2
-$(GNAME FunctionAttributes):
-	$(GLINK FunctionAttribute)
-	$(GLINK FunctionAttribute) $(I FunctionAttributes)
-
-$(GNAME FunctionAttribute):
-	$(B nothrow)
-	$(B pure)
+$(FunctionAttributes_production)
+$(FunctionAttribute_production)
 )
-$(GNAME MemberFunctionAttributes):
-	$(GLINK MemberFunctionAttribute)
-	$(GLINK MemberFunctionAttribute) $(I MemberFunctionAttributes)
+$(MemberFunctionAttributes_production)
+$(MemberFunctionAttribute_production)
+$(DefaultInitializerExpression_production)
+$(Initializer_production)
+$(NonVoidInitializer_production)
+$(ArrayInitializer_production)
+$(ArrayMemberInitializations_production)
+$(ArrayMemberInitialization_production)
+$(StructInitializer_production)
+$(StructMemberInitializers_production)
+$(StructMemberInitializer_production)
 
-$(GNAME MemberFunctionAttribute):
-	$(B const)
-	$(B immutable)
-	$(B inout)
-	$(B shared)
-	$(GLINK FunctionAttribute)
-
-$(GNAME DefaultInitializerExpression):
-	$(ASSIGNEXPRESSION)
-$(V2
-	$(B __FILE__)
-	$(B __LINE__))
-
-$(GNAME Initializer):
-        $(GLINK VoidInitializer)
-	$(GLINK NonVoidInitializer)
-
-$(GNAME NonVoidInitializer):
-        $(ASSIGNEXPRESSION)
-        $(GLINK ArrayInitializer)
-        $(GLINK StructInitializer)
-
-$(GNAME ArrayInitializer):
-	$(B [ ])
-	$(B [) $(GLINK ArrayMemberInitializations) $(B ])
-
-$(GNAME ArrayMemberInitializations):
-	$(GLINK ArrayMemberInitialization)
-	$(GLINK ArrayMemberInitialization) $(B ,)
-	$(GLINK ArrayMemberInitialization) $(B ,) $(I ArrayMemberInitializations)
-
-$(GNAME ArrayMemberInitialization):
-	$(GLINK NonVoidInitializer)
-	$(ASSIGNEXPRESSION) $(B :) $(GLINK NonVoidInitializer)
-
-$(GNAME StructInitializer):
-	$(B {  })
-	$(B {) $(GLINK StructMemberInitializers) $(B })
-
-$(GNAME StructMemberInitializers):
-	$(GLINK StructMemberInitializer)
-	$(GLINK StructMemberInitializer) $(B ,)
-	$(GLINK StructMemberInitializer) $(B ,) $(I StructMemberInitializers)
-
-$(GNAME StructMemberInitializer):
-	$(GLINK NonVoidInitializer)
-	$(I Identifier) $(B :) $(GLINK NonVoidInitializer)
-)
-
 <h3>Declaration Syntax</h3>
 
 $(P Declaration syntax generally reads right to left:)
@@ -271,10 +100,7 @@
 
 <h3><a name="AutoDeclaration">Implicit Type Inference</a></h3>
 
-$(GRAMMAR
-$(GNAME AutoDeclaration):
-	$(I StorageClasses) $(I Identifier) $(B =) $(ASSIGNEXPRESSION) $(B ;)
-)
+$(AutoDeclaration_production)
 
 	$(P If a declaration starts with a $(I StorageClass) and has
 	a $(I NonVoidInitializer) from which the type can be inferred,
@@ -493,11 +319,7 @@
 
 <h3><a name="typeof">typeof</a></h3>
 
-$(GRAMMAR
-$(GNAME Typeof):
-        $(B typeof $(LPAREN)) $(EXPRESSION) $(B $(RPAREN))
-        $(B typeof $(LPAREN)) $(B return) $(B $(RPAREN))
-)
+$(Typeof_production)
 
 	$(P 
 	$(I Typeof) is a way to specify a type based on the type
@@ -573,10 +395,7 @@
 
 <h3>Void Initializations</h3>
 
-$(GRAMMAR
-$(GNAME VoidInitializer):
-	$(B void)
-)
+$(VoidInitializer_production)
 
 	Normally, variables are initialized either with an explicit
 	$(I Initializer) or are set to the default value for the
Index: doc.ddoc
===================================================================
--- doc.ddoc	(revision 1638)
+++ doc.ddoc	(working copy)
@@ -42,7 +42,7 @@
 	)
 	</div>
 
-	<div id="lastupdate">Last update $(DATETIME)</div>
+	<div id="lastupdate">Last update </div>
 </div>
 
 $(BODY)
Index: enum.dd
===================================================================
--- enum.dd	(revision 1638)
+++ enum.dd	(working copy)
@@ -2,35 +2,13 @@
 
 $(SPEC_S Enums - Enumerated Types,
 
-$(GRAMMAR
-$(GNAME EnumDeclaration):
-	$(B enum) $(I EnumTag) $(I EnumBody)
-	$(B enum) $(I EnumBody)
-	$(B enum) $(I EnumTag) $(B :) $(I EnumBaseType) $(I EnumBody)
-	$(B enum) $(B :) $(I EnumBaseType) $(I EnumBody)
+$(EnumDeclaration_production)
+$(EnumTag_production)
+$(EnumBaseType_production)
+$(EnumBody_production)
+$(EnumMembers_production)
+$(EnumMember_production)
 
-$(GNAME EnumTag):
-	$(I Identifier)
-
-$(GNAME EnumBaseType):
-	$(I Type)
-
-$(GNAME EnumBody):
-	$(B ;)
-	$(B {) $(I EnumMembers) $(B })
-
-$(GNAME EnumMembers):
-	$(I EnumMember)
-	$(I EnumMember) $(B ,)
-	$(I EnumMember) $(B ,) $(I EnumMembers)
-
-$(GNAME EnumMember):
-	$(I Identifier)
-	$(I Identifier) $(B =) $(ASSIGNEXPRESSION)
-$(V2
-	$(I Type) $(I Identifier) $(B =) $(ASSIGNEXPRESSION))
-)
-
 	$(P Enum declarations are used to define a group of constants.
 	They come in two forms:
 	)
